<template>
    <double-layout-widget
      :title="$t('deliveryTitle')"
      :description="$t('deliveryDescription')"
    >
        <template #left>
          <div class="p-delivery__select-wrapper"
            :class="{'p-delivery__select-wrapper--error': !checkList.length  && current}"
          >
            <div class="p-delivery__select-button"
              @click="clearSelect"
            >
              {{ !current ? $t('enter') : 'X'  }}
            </div>  
            <select
              v-model="current"
              class="p-delivery__select"
              name="lang"
              @change="handleCity($event.target.value)"
            >
              <option value="" disabled selected>{{$t('selectedCity')}}</option>
              <option 
                  v-for="(city, index) in cities"
                  :key="`city-${index}`"
                  class="lang-swither__item"
                  :value="city"
                  :selected="current === city"
              >
                  {{ city }}
              </option>
            </select>
          </div>
          <div v-if="!checkList.length  && current"
            class="p-delivery__error"
          >
            {{ $t('deliveryCityError')}}
          </div>
          <h5 class="p-delivery__popular-title"
            :class="{'p-delivery__popular-list--mobile-hide': current}"
          >
            {{ $t('deliveryPopular')}}
          </h5>
          <div class="p-delivery__popular-list"
            :class="{'p-delivery__popular-list--mobile-hide': current}"
          >
            <div v-for="(city, index) in cities"
              :key="`popular-city-${index}`"
              class="p-delivery__popular-item c-latin-charm b-bright-gray"
              @click="handleCity(city)"
            >
              {{ city }}
            </div>
          </div>
        </template>
        <template #right>
            <div v-if="!checkList.length" class="p-delivery__right">
              <h2>Fast  Service</h2>
              <div class="p-delivery__right-image" />
            </div>
            <div v-if="checkList.length && current"
              class="p-delivery__right"
            >
              <div v-for="price in checkList"
                :key="`${price.type}-${price.city}`"
                class="p-delivery-card"
                @click="getSelected(price.type)"
              >
                <div class="p-delivery-card__column">
                  <div class="p-delivery-card__title">{{ $t(price.type) }}</div>

                  <div class="p-delivery-card__price">{{ price.price }}$</div>
                </div>
                <div
                  class="p-delivery-card__column"
                  :class="{'p-delivery-card__column--selected-image': selectedType === price.type}"
                >
                  <img :src="require(`@/assets/images/delivery/${price.type}.png`)" :alt="price.type" />
                </div>
                <div v-if="selectedType === price.type" class="p-delivery-card__column p-delivery-card__column--checked">
                </div>
              </div>
            </div>
        </template>
    </double-layout-widget>
</template>

<script>
import { ref } from 'vue';
import DoubleLayoutWidget from '@/widgets/doubleLayout';
import DeliveryService from '@/services/DeliveryService';

export default {
  name: 'DeliveryPage',

  components: {
    DoubleLayoutWidget
  },

  setup() {
    const dSrv = new DeliveryService();
    const cities = ref(dSrv.getCitys());
    const current = ref('');
    const checkList = ref([]);
    const selectedType = ref('pickup');

    const handleCity = async (city) => {
        checkList.value = await dSrv.check(city);
        current.value = city;
        selectedType.value = 'pickup';
    };

    const getSelected = (type) => {
      selectedType.value = type;
    };

    const clearSelect = () => {
      current.value = '';
      checkList.value = [];
      selectedType.value = 'pickup';
    };

    return {
      current,
      cities,
      checkList,
      selectedType,
      handleCity,
      getSelected,
      clearSelect
    };
  }
}
</script>

<style lang="scss" scoped>
@import '@/scss/configuration/colors.scss';
@import '@/scss/configuration/variables';
@import '@/scss/mixins/sbg.scss';
@import '@/scss/mixins/pos.scss';
@import '@/scss/mixins/sflx.scss';

.p-delivery__right {
  width: 100%;
  height: 100%;
  @include pos();

  h2 {
    @include pos($p: absolute, $t: 0, $r: 0,  $z: 1);
    font-size: 4.6rem;
    opacity: 0.1;
    margin: 0;
    max-width: 50%;
  }
  .p-delivery__right-image {
    width: 100%;
    height: 100%;
    min-height: 321px;
    @include sbg($i: '@/assets/images/car.png', $s: cover);
    @include pos($p: absolute,  $z: 2);
  }
}

.p-delivery__popular-list {
  @include sflx($juscont: space-between,  $wrap: wrap);
  width: 100%;
}

.p-delivery__popular-item  {
  flex: 0 0 35%;
  opacity: 0.5;
  padding: 0.8rem;
  border-bottom: 1px solid;
  cursor: pointer;
  &:hover {
    opacity: 0.8;
  }
}

.p-delivery-card {
  @include sflx($juscont: space-between);
  border: 1px solid $cBrightGray;
  background: $cWhite;
  border-radius: 2.2rem;
  margin-bottom: 1.8rem;
  width: 80%;
  margin-left: 10%;
}

.p-delivery-card__column {
  @include sflx($dir: column, $alitems: stretch, $juscont: space-between);
  padding: 2.2rem 4.5rem;
  flex: 1;

  &--selected-image {
    padding-right: 0;
  }

  > img {
    width: 100%;
    height: auto;
    margin: auto;
  }

  &--checked {
    background: #65B3E4;
    flex: 0 0 2.2rem;
    padding-right: 0;
    border-radius: 0 2.2rem 2.2rem 0;
  }

}
.p-delivery-card__title {
  color: $cLatinCharm;
  font-weight: 700;
  font-size: 36px;
}
.p-delivery-card__price {
  color: #78A1BB;
  font-weight: 700;
  font-size: 50px;
  margin-top: 80px;
}
.p-delivery__error {
  color: #FF4757;
  font-size: 20px;
  margin-top: 15px;
}


@media screen and ( max-width: 767px ) {
  .p-delivery__right {
    h2 {
      font-size: 2.6rem;
    }
  }
  .p-delivery__popular-list {
      &--mobile-hide {
        display: none;
      }
  }
  .p-delivery-card__title {
    color: $cLatinCharm;
    font-weight: 700;
    font-size: 26px;
  }
  .p-delivery-card__price {
    color: #78A1BB;
    font-weight: 700;
    font-size: 30px;
    margin-top: 30px;
  }
}

.p-delivery__select-wrapper {
  @include pos();
  width: 100%;
  &--error {
    .p-delivery__select-button  {
      background: #FF4757;
    }
    .p-delivery__select {
      border-color: #FF4757;
    }
  }
}

.p-delivery__select-button {
  height: 100%;
  background: #65B3E4;
  @include pos($p: absolute, $t: 0, $r: 0,  $z: 1);
  @include sflx($dir: column, $alitems: center, $juscont: center);
  padding: 0 48px;
  border-radius: 50px;
  color: $cWhite;
}

.p-delivery__select {
  width: 100%;
  padding: 18px 36px;
  border-radius: 50px;
  appearance: none;
  border-color: #E9F0EB;
}
</style>
